Loading...
Searching...
No Matches
gtsam::EliminateableFactorGraph< FACTOR_GRAPH > Class Template Reference

## Detailed Description

template<class FACTOR_GRAPH>
class gtsam::EliminateableFactorGraph< FACTOR_GRAPH >

EliminateableFactorGraph is a base class for factor graphs that contains elimination algorithms.

Any factor graph holding eliminateable factors can derive from this class to expose functions for computing marginals, conditional marginals, doing multifrontal and sequential elimination, etc.

## Public Member Functions

boost::shared_ptr< BayesNetType > | eliminateSequential (OptionalOrderingType orderingType=boost::none, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Do sequential elimination of all variables to produce a Bayes net.
boost::shared_ptr< BayesNetType > | eliminateSequential (const Ordering &ordering, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Do sequential elimination of all variables to produce a Bayes net.
boost::shared_ptr< BayesTreeType > | eliminateMultifrontal (OptionalOrderingType orderingType=boost::none, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Do multifrontal elimination of all variables to produce a Bayes tree.
boost::shared_ptr< BayesTreeType > | eliminateMultifrontal (const Ordering &ordering, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Do multifrontal elimination of all variables to produce a Bayes tree.
std::pair< boost::shared_ptr< BayesNetType >, boost::shared_ptr< FactorGraphType > > | eliminatePartialSequential (const Ordering &ordering, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Do sequential elimination of some variables, in `ordering` provided, to produce a Bayes net and a remaining factor graph.
std::pair< boost::shared_ptr< BayesNetType >, boost::shared_ptr< FactorGraphType > > | eliminatePartialSequential (const KeyVector &variables, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Do sequential elimination of the given `variables` in an ordering computed by COLAMD to produce a Bayes net and a remaining factor graph.
std::pair< boost::shared_ptr< BayesTreeType >, boost::shared_ptr< FactorGraphType > > | eliminatePartialMultifrontal (const Ordering &ordering, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Do multifrontal elimination of some variables, in `ordering` provided, to produce a Bayes tree and a remaining factor graph.
std::pair< boost::shared_ptr< BayesTreeType >, boost::shared_ptr< FactorGraphType > > | eliminatePartialMultifrontal (const KeyVector &variables, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Do multifrontal elimination of the given `variables` in an ordering computed by COLAMD to produce a Bayes tree and a remaining factor graph.
boost::shared_ptr< BayesNetType > | marginalMultifrontalBayesNet (boost::variant< const Ordering &, const KeyVector & > variables, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Compute the marginal of the requested variables and return the result as a Bayes net.
boost::shared_ptr< BayesNetType > | marginalMultifrontalBayesNet (boost::variant< const Ordering &, const KeyVector & > variables, const Ordering &marginalizedVariableOrdering, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Compute the marginal of the requested variables and return the result as a Bayes net.
boost::shared_ptr< BayesTreeType > | marginalMultifrontalBayesTree (boost::variant< const Ordering &, const KeyVector & > variables, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Compute the marginal of the requested variables and return the result as a Bayes tree.
boost::shared_ptr< BayesTreeType > | marginalMultifrontalBayesTree (boost::variant< const Ordering &, const KeyVector & > variables, const Ordering &marginalizedVariableOrdering, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Compute the marginal of the requested variables and return the result as a Bayes tree.
boost::shared_ptr< FactorGraphType > | marginal (const KeyVector &variables, const Eliminate &function=EliminationTraitsType::DefaultEliminate, OptionalVariableIndex variableIndex=boost::none) const
| Compute the marginal factor graph of the requested variables.

## Public Types

typedef EliminationTraits< FactorGraphType > | EliminationTraitsType
| Typedef to the specific EliminationTraits for this graph.
typedef EliminationTraitsType::ConditionalType | ConditionalType
| Conditional type stored in the Bayes net produced by elimination.
typedef EliminationTraitsType::BayesNetType | BayesNetType
| Bayes net type produced by sequential elimination.
typedef EliminationTraitsType::EliminationTreeType | EliminationTreeType
| Elimination tree type that can do sequential elimination of this graph.
typedef EliminationTraitsType::BayesTreeType | BayesTreeType
| Bayes tree type produced by multifrontal elimination.
typedef EliminationTraitsType::JunctionTreeType | JunctionTreeType
| Junction tree type that can do multifrontal elimination of this graph.
typedef std::pair< boost::shared_ptr< ConditionalType >, boost::shared_ptr< _FactorType > > | EliminationResult
| The pair of conditional and remaining factor produced by a single dense elimination step on a subgraph.
typedef std::function< EliminationResult(const FactorGraphType &, const Ordering &)> | Eliminate
| The function type that does a single dense elimination step on a subgraph.
typedef boost::optional< const VariableIndex & > | OptionalVariableIndex
| Typedef for an optional variable index as an argument to elimination functions.
typedef boost::optional< Ordering::OrderingType > | OptionalOrderingType
| Typedef for an optional ordering type.

## Member Function Documentation

## eliminateMultifrontal() [1/2]

template<class FACTORGRAPH>

boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesTreeType > gtsam::EliminateableFactorGraph< FACTORGRAPH >::eliminateMultifrontal | ( | const Ordering & | ordering,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Do multifrontal elimination of all variables to produce a Bayes tree.

If an ordering is not provided, the ordering will be computed using either COLAMD or METIS, depending on the parameter orderingType (Ordering::COLAMD or Ordering::METIS)

Example - Full QR elimination in specified order:

boost::shared_ptr<GaussianBayesTree> result = graph.eliminateMultifrontal(EliminateQR, myOrdering);
gtsam::EliminateQR
std::pair< GaussianConditional::shared_ptr, JacobianFactor::shared_ptr > EliminateQR(const GaussianFactorGraph &factors, const Ordering &keys)
Multiply all factors and eliminate the given keys from the resulting factor using a QR variant that h...
Definition JacobianFactor.cpp:789

## eliminateMultifrontal() [2/2]

template<class FACTORGRAPH>

boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesTreeType > gtsam::EliminateableFactorGraph< FACTORGRAPH >::eliminateMultifrontal | ( | OptionalOrderingType | orderingType = boost::none,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Do multifrontal elimination of all variables to produce a Bayes tree.

If an ordering is not provided, the ordering will be computed using either COLAMD or METIS, depending on the parameter orderingType (Ordering::COLAMD or Ordering::METIS)

Example - Full Cholesky elimination in COLAMD order:

boost::shared_ptr<GaussianBayesTree> result = graph.eliminateMultifrontal(EliminateCholesky);
gtsam::EliminateCholesky
std::pair< boost::shared_ptr< GaussianConditional >, boost::shared_ptr< HessianFactor > > EliminateCholesky(const GaussianFactorGraph &factors, const Ordering &keys)
Densely partially eliminate with Cholesky factorization.
Definition HessianFactor.cpp:525

Example - Reusing an existing VariableIndex to improve performance, and using COLAMD ordering:

VariableIndex varIndex(graph); // Build variable index
Data data = otherFunctionUsingVariableIndex(graph, varIndex); // Other code that uses variable index
boost::shared_ptr<GaussianBayesTree> result = graph.eliminateMultifrontal(EliminateQR, boost::none, varIndex);
gtsam::VariableIndex
The VariableIndex class computes and stores the block column structure of a factor graph.
Definition VariableIndex.h:43

## eliminatePartialMultifrontal() [1/2]

template<class FACTORGRAPH>

std::pair< boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesTreeType >, boost::shared_ptr< FACTORGRAPH > > gtsam::EliminateableFactorGraph< FACTORGRAPH >::eliminatePartialMultifrontal | ( | const KeyVector & | variables,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Do multifrontal elimination of the given `variables` in an ordering computed by COLAMD to produce a Bayes tree and a remaining factor graph.

This computes the factorization \( p(X) = p(A|B) p(B) \), where \( A = \) `variables`, \( X \) is all the variables in the factor graph, and \( B = X\backslash A \).

## eliminatePartialMultifrontal() [2/2]

template<class FACTORGRAPH>

std::pair< boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesTreeType >, boost::shared_ptr< FACTORGRAPH > > gtsam::EliminateableFactorGraph< FACTORGRAPH >::eliminatePartialMultifrontal | ( | const Ordering & | ordering,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Do multifrontal elimination of some variables, in `ordering` provided, to produce a Bayes tree and a remaining factor graph.

This computes the factorization \( p(X) = p(A|B) p(B) \), where \( A = \) `variables`, \( X \) is all the variables in the factor graph, and \( B = X\backslash A \).

## eliminatePartialSequential() [1/2]

template<class FACTORGRAPH>

std::pair< boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesNetType >, boost::shared_ptr< FACTORGRAPH > > gtsam::EliminateableFactorGraph< FACTORGRAPH >::eliminatePartialSequential | ( | const KeyVector & | variables,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Do sequential elimination of the given `variables` in an ordering computed by COLAMD to produce a Bayes net and a remaining factor graph.

This computes the factorization \( p(X) = p(A|B) p(B) \), where \( A = \) `variables`, \( X \) is all the variables in the factor graph, and \( B = X\backslash A \).

## eliminatePartialSequential() [2/2]

template<class FACTORGRAPH>

std::pair< boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesNetType >, boost::shared_ptr< FACTORGRAPH > > gtsam::EliminateableFactorGraph< FACTORGRAPH >::eliminatePartialSequential | ( | const Ordering & | ordering,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Do sequential elimination of some variables, in `ordering` provided, to produce a Bayes net and a remaining factor graph.

This computes the factorization \( p(X) = p(A|B) p(B) \), where \( A = \) `variables`, \( X \) is all the variables in the factor graph, and \(B = X\backslash A \).

## eliminateSequential() [1/2]

template<class FACTORGRAPH>

boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesNetType > gtsam::EliminateableFactorGraph< FACTORGRAPH >::eliminateSequential | ( | const Ordering & | ordering,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Do sequential elimination of all variables to produce a Bayes net.

Example - Full QR elimination in specified order:

boost::shared_ptr<GaussianBayesNet> result = graph.eliminateSequential(myOrdering, EliminateQR);

Example - Reusing an existing VariableIndex to improve performance:

VariableIndex varIndex(graph); // Build variable index
Data data = otherFunctionUsingVariableIndex(graph, varIndex); // Other code that uses variable index
boost::shared_ptr<GaussianBayesNet> result = graph.eliminateSequential(myOrdering, EliminateQR, varIndex, boost::none);

## eliminateSequential() [2/2]

template<class FACTORGRAPH>

boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesNetType > gtsam::EliminateableFactorGraph< FACTORGRAPH >::eliminateSequential | ( | OptionalOrderingType | orderingType = boost::none,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Do sequential elimination of all variables to produce a Bayes net.

If an ordering is not provided, the ordering provided by COLAMD will be used.

Example - Full Cholesky elimination in COLAMD order:

boost::shared_ptr<GaussianBayesNet> result = graph.eliminateSequential(EliminateCholesky);

Example - METIS ordering for elimination

boost::shared_ptr<GaussianBayesNet> result = graph.eliminateSequential(OrderingType::METIS);

Example - Reusing an existing VariableIndex to improve performance, and using COLAMD ordering:

VariableIndex varIndex(graph); // Build variable index
Data data = otherFunctionUsingVariableIndex(graph, varIndex); // Other code that uses variable index
boost::shared_ptr<GaussianBayesNet> result = graph.eliminateSequential(EliminateQR, varIndex, boost::none);

## marginalMultifrontalBayesNet() [1/2]

template<class FACTORGRAPH>

boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesNetType > gtsam::EliminateableFactorGraph< FACTORGRAPH >::marginalMultifrontalBayesNet | ( | boost::variant< const Ordering &, const KeyVector & > | variables,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Compute the marginal of the requested variables and return the result as a Bayes net.

Uses COLAMD marginalization ordering by default

Parameters

  variables | Determines the variables whose marginal to compute, if provided as an Ordering they will be ordered in the returned BayesNet as specified, and if provided as a KeyVector they will be ordered using constrained COLAMD.
  function | Optional dense elimination function, if not provided the default will be used.
  variableIndex | Optional pre-computed VariableIndex for the factor graph, if not provided one will be computed.

## marginalMultifrontalBayesNet() [2/2]

template<class FACTORGRAPH>

boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesNetType > gtsam::EliminateableFactorGraph< FACTORGRAPH >::marginalMultifrontalBayesNet | ( | boost::variant< const Ordering &, const KeyVector & > | variables,
|  | const Ordering & | marginalizedVariableOrdering,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Compute the marginal of the requested variables and return the result as a Bayes net.

Parameters

  variables | Determines the variables whose marginal to compute, if provided as an Ordering they will be ordered in the returned BayesNet as specified, and if provided as a KeyVector they will be ordered using constrained COLAMD.
  marginalizedVariableOrdering | Ordering for the variables being marginalized out, i.e. all variables not in `variables`.
  function | Optional dense elimination function, if not provided the default will be used.
  variableIndex | Optional pre-computed VariableIndex for the factor graph, if not provided one will be computed.

## marginalMultifrontalBayesTree() [1/2]

template<class FACTORGRAPH>

boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesTreeType > gtsam::EliminateableFactorGraph< FACTORGRAPH >::marginalMultifrontalBayesTree | ( | boost::variant< const Ordering &, const KeyVector & > | variables,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Compute the marginal of the requested variables and return the result as a Bayes tree.

Uses COLAMD marginalization order by default

Parameters

  variables | Determines the variables whose marginal to compute, if provided as an Ordering they will be ordered in the returned BayesNet as specified, and if provided as a KeyVector they will be ordered using constrained COLAMD.
  function | Optional dense elimination function, if not provided the default will be used.
  variableIndex | Optional pre-computed VariableIndex for the factor graph, if not provided one will be computed.

## marginalMultifrontalBayesTree() [2/2]

template<class FACTORGRAPH>

boost::shared_ptr< typename EliminateableFactorGraph< FACTORGRAPH >::BayesTreeType > gtsam::EliminateableFactorGraph< FACTORGRAPH >::marginalMultifrontalBayesTree | ( | boost::variant< const Ordering &, const KeyVector & > | variables,
|  | const Ordering & | marginalizedVariableOrdering,
|  | const Eliminate & | function = EliminationTraitsType::DefaultEliminate,
|  | OptionalVariableIndex | variableIndex = boost::none ) const

Compute the marginal of the requested variables and return the result as a Bayes tree.

Parameters

  variables | Determines the variables whose marginal to compute, if provided as an Ordering they will be ordered in the returned BayesNet as specified, and if provided as a KeyVector they will be ordered using constrained COLAMD.
  marginalizedVariableOrdering | Ordering for the variables being marginalized out, i.e. all variables not in `variables`.
  function | Optional dense elimination function, if not provided the default will be used.
  variableIndex | Optional pre-computed VariableIndex for the factor graph, if not provided one will be computed.

The documentation for this class was generated from the following files:

- /build/gtsam-RkN8wG/gtsam-4.2.2+dfsg/gtsam/inference/EliminateableFactorGraph.h
- /build/gtsam-RkN8wG/gtsam-4.2.2+dfsg/gtsam/inference/EliminateableFactorGraph-inst.h